#include <cmath>
#include <iostream>
using namespace std;
void ispisi(int* a, int n)
{
     for(int i=0; i<n; i++)
    {
        cout << a[i] << " ";
    }
    cout << endl;
}
int main()
{
    int m, n, y;
    cin >> n >> m;
    int* b=new int[m+1];
    b[0]=0;
    for(int i=1; i<=m; i++)
    {
        cin >> b[i];
    }
    int* c=new int[n+1];
    for(int i=0; i<=n; i++)
    {
        c[i]=i;
    }

    for(int i=0; i<=n-m; i++)
    {
        for(int j=1; j<=m; j++)
        {
            c[i+b[j]]=c[i+j];
        }
        ispisi(c, n);
    }
    int s=0;

    cin >> y;
    for(int i=0; i<=n; i++)
    {
        s+=pow(y, i)*c[i];
    }
    ispisi(c, n);
    cout << s%998244353;

    return 0;
}